pragma Source_File_Name (ada_main, Spec_File_Name => "b~principal.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~principal.adb");

package body ada_main is

   procedure Do_Finalize;
   pragma Import (C, Do_Finalize, "system__standard_library__adafinal");

   procedure adainit is
      E045 : Boolean; pragma Import (Ada, E045, "system__os_primitives_E");
      E008 : Boolean; pragma Import (Ada, E008, "ada__exceptions_E");
      E014 : Boolean; pragma Import (Ada, E014, "system__exception_table_E");
      E006 : Boolean; pragma Import (Ada, E006, "ada__calendar_E");
      E069 : Boolean; pragma Import (Ada, E069, "ada__io_exceptions_E");
      E119 : Boolean; pragma Import (Ada, E119, "ada__numerics_E");
      E041 : Boolean; pragma Import (Ada, E041, "interfaces__c_E");
      E017 : Boolean; pragma Import (Ada, E017, "system__exceptions_E");
      E043 : Boolean; pragma Import (Ada, E043, "interfaces__c__strings_E");
      E028 : Boolean; pragma Import (Ada, E028, "system__secondary_stack_E");
      E052 : Boolean; pragma Import (Ada, E052, "ada__tags_E");
      E050 : Boolean; pragma Import (Ada, E050, "ada__streams_E");
      E024 : Boolean; pragma Import (Ada, E024, "system__soft_links_E");
      E060 : Boolean; pragma Import (Ada, E060, "system__finalization_root_E");
      E062 : Boolean; pragma Import (Ada, E062, "system__finalization_implementation_E");
      E058 : Boolean; pragma Import (Ada, E058, "ada__finalization_E");
      E073 : Boolean; pragma Import (Ada, E073, "ada__finalization__list_controller_E");
      E071 : Boolean; pragma Import (Ada, E071, "system__file_control_block_E");
      E056 : Boolean; pragma Import (Ada, E056, "system__file_io_E");
      E049 : Boolean; pragma Import (Ada, E049, "ada__text_io_E");
      E121 : Boolean; pragma Import (Ada, E121, "ordenacion_E");

      Restrictions : constant String :=
        "nnvvnvvvnnnnnvvvvvvnvvvnvnnvnnnvnvvnnnnnnvvvvnnnvvnn";

      procedure Set_Globals
        (Main_Priority            : Integer;
         Time_Slice_Value         : Integer;
         WC_Encoding              : Character;
         Locking_Policy           : Character;
         Queuing_Policy           : Character;
         Task_Dispatching_Policy  : Character;
         Restrictions             : System.Address;
         Unreserve_All_Interrupts : Integer;
         Exception_Tracebacks     : Integer;
         Zero_Cost_Exceptions     : Integer);
      pragma Import (C, Set_Globals, "__gnat_set_globals");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");
   begin
      Set_Globals
        (Main_Priority            => -1,
         Time_Slice_Value         => -1,
         WC_Encoding              => 'b',
         Locking_Policy           => ' ',
         Queuing_Policy           => ' ',
         Task_Dispatching_Policy  => ' ',
         Restrictions             => Restrictions'Address,
         Unreserve_All_Interrupts => 0,
         Exception_Tracebacks     => 0,
         Zero_Cost_Exceptions     => 0);

      if Handler_Installed = 0 then
        Install_Handler;
      end if;
      if not E008 then
         Ada.Exceptions'Elab_Spec;
      end if;
      if not E014 then
         System.Exception_Table'Elab_Body;
         E014 := True;
      end if;
      if not E006 then
         Ada.Calendar'Elab_Spec;
      end if;
      if not E069 then
         Ada.Io_Exceptions'Elab_Spec;
         E069 := True;
      end if;
      if not E119 then
         Ada.Numerics'Elab_Spec;
         E119 := True;
      end if;
      if not E041 then
         Interfaces.C'Elab_Spec;
      end if;
      if not E017 then
         System.Exceptions'Elab_Spec;
         E017 := True;
      end if;
      if not E043 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      if not E045 then
         System.Os_Primitives'Elab_Body;
         E045 := True;
      end if;
      E041 := True;
      if not E052 then
         Ada.Tags'Elab_Spec;
      end if;
      if not E052 then
         Ada.Tags'Elab_Body;
         E052 := True;
      end if;
      if not E050 then
         Ada.Streams'Elab_Spec;
         E050 := True;
      end if;
      if not E024 then
         System.Soft_Links'Elab_Body;
         E024 := True;
      end if;
      if not E028 then
         System.Secondary_Stack'Elab_Body;
         E028 := True;
      end if;
      E043 := True;
      E006 := True;
      if not E060 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E060 := True;
      if not E008 then
         Ada.Exceptions'Elab_Body;
         E008 := True;
      end if;
      if not E062 then
         System.Finalization_Implementation'Elab_Spec;
      end if;
      if not E062 then
         System.Finalization_Implementation'Elab_Body;
         E062 := True;
      end if;
      if not E058 then
         Ada.Finalization'Elab_Spec;
      end if;
      E058 := True;
      if not E073 then
         Ada.Finalization.List_Controller'Elab_Spec;
      end if;
      E073 := True;
      if not E071 then
         System.File_Control_Block'Elab_Spec;
         E071 := True;
      end if;
      if not E056 then
         System.File_Io'Elab_Body;
         E056 := True;
      end if;
      if not E049 then
         Ada.Text_Io'Elab_Spec;
      end if;
      if not E049 then
         Ada.Text_Io'Elab_Body;
         E049 := True;
      end if;
      E121 := True;
   end adainit;

   procedure adafinal is
   begin
      Do_Finalize;
   end adafinal;

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure initialize;
      pragma Import (C, initialize, "__gnat_initialize");

      procedure finalize;
      pragma Import (C, finalize, "__gnat_finalize");


      procedure Ada_Main_Program;
      pragma Import (Ada, Ada_Main_Program, "_ada_principal");

      Ensure_Reference : System.Address := Ada_Main_Program_Name'Address;

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize;
      adainit;
      Break_Start;
      Ada_Main_Program;
      Do_Finalize;
      Finalize;
      return (gnat_exit_status);
   end;

-- BEGIN Object file/option list
   --   ./ordenacion.o
   --   ./principal.o
   --   -L./
   --   -LC:\DOCUME~1\ADMINI~1\ESCRIT~1\ocSort\
   --   -LC:\GNAT\lib\gcc-lib\pentium-mingw32msv\2.8.1\adalib\
   --   -static
   --   -lgnarl
   --   -lgnat
   --   -Wl,--stack=0x2000000
-- END Object file/option list   

end ada_main;
