-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- Fichero: ordenacion.adb                                                   --
-- Tema:    Fichero de implementacion de procedimientos de ordenacion        --
-- Fecha:   Diciembre de 2007                                                --
-- Versin: 1.0                                                              --
-- Autor:   Ruben Alejandro Escartin Aparicio                                --
-- Email Univerisdad:   543588@unizar.es                                     --
-- Email Personal:  emulao@gmail.com                                         --
-- Descripcion: Implementacin de algoritmos de ordenacin                   --
-- El cdigo actual usa procedimientos de medida de tiempos de una practica  --
-- de la asignatura Metodologa de la programacin, del CPS de Zaragoza,     --
-- realizada por Rubn Escartn, Carlos Asn Bernal y Luis Miguel Alonso     --
-- en 2006.                                                                  --
-- La implementacin de Quicksort, ordenacin por insercin y puede que      --
--  alguna lnea ms, corresponden a los profesores de la asignatura         --
-- a los profesores de la asignatura, Fernando Tricas y Javier Martnez.     --
-- Todas las implementaciones de los algoritmos de Merge y de Ordenacin     --
-- restantes, son originales de Rubn Escartn en Noviembre-Diciembre de 2007--
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
package body ordenacion is
-------------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   --                  ALGORITMOS DE SWAP                                    --                  
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   
   ----------------------------------------------------------------------------
   procedure Swap (
         A,
         B : in out Tpdato) is
      -- Pre: A=x AND B=y       
      -- Post: A=y AND B=x
      -------------------------------------------------------------------------
      Aux : Tpdato;
   begin
      Aux := A;
      A := B;
      B := Aux;
   end Swap;
   ----------------------------------------------------------------------------
      
   ----------------------------------------------------------------------------
   procedure swapInvirtiendo(v:in out tpVector;pivote:integer) is
      --pre: v(v'first..medio2)=v1 AND v(medio2+1..v'last)=v2
      --post: v(v'first..pivote-1):=v2 AND v(pivote..last):=v1
      ----------------------------------------------------------------------------
      procedure invierte(v:in out tpVector) is
         --post: invertido(v)
      begin
         if v'first<v'last then
            swap(v(v'first),v(v'last));
            invierte(v(v'first+1..v'last-1));
         end if;
      end invierte;
      -------------------------------------------------------------------------
      begin
         invierte(v);
         invierte(v(v'first..pivote-1));
         invierte(v(pivote..v'last));
   end swapInvirtiendo;
   ----------------------------------------------------------------------------
   
----------------------------------------------------------------------------
   procedure swapConSwaps(v:in out tpVector;v1l:integer) is
         --pre: v(v'first..medio2)=v1 AND v(medio2+1..v'last)=v2
         --post: v(v'first..pivote-1):=v2 AND v(pivote..last):=v1
      ----------------------------------------------------------------------------
      procedure iSwapConSwaps(v1,v2:in out tpVector) is
            --pre: v(v'first..medio2)=v1 AND v(medio2+1..v'last)=v2
            --post: v(v'first..pivote-1):=v2 AND v(pivote..last):=v1
      begin
         if v1'first<=v1'last then
            if v2'first<=v2'last then
               swap(v1(v1'first),v2(v2'first));
               iswapConSwaps(v1(v1'first+1..v1'last),v2(v2'first+1..v2'last));
            else
               swapConSwaps(v(v1'first..v'last),v1'last);
            end if;
         elsif v2'first<=v2'last then
            swapConSwaps(v(v1'first..v'last),v2'first-1);
         end if;     
      end iSwapConSwaps;
      ----------------------------------------------------------------------------
   begin
      if v'first<=v1l and v1l+1<=v'last then
            swap(v(v'first),v(v1l+1)); 
            iSwapConSwaps(v(v'first+1..v1l),v(v1l+2..v'last));   
      end if;
   end swapConSwaps;
   ----------------------------------------------------------------------------

   
   ----------------------------------------------------------------------------
   procedure oSwap(v:in out tpVector;v1l,pivote:integer) is
         --pre: v(v'first..medio2)=v1 AND v(medio2+1..v'last)=v2
         --post: v(v'first..pivote-1):=v2 AND v(pivote..last):=v1
      -------------------------------------------------------------------------
      procedure ioSwap(v:in out tpVector;v1l,pivote:integer;
      aux1:tpDato) is
         aux2:tpDato;
      begin
         if pivote=v1l+1 then --finalizacion
            v(pivote):=aux1;
         else
            aux2:=v(pivote);
            v(pivote):=aux1;
            if pivote<=v1l then
               ioSwap(v,v1l,v'last-(v1l-pivote),aux2);
            else --pivote>v1l+1
               ioSwap(v,v1l,v'first+(pivote-(v1l+1)),aux2);
            end if;
         end if;  
      end ioSwap; 
      -------------------------------------------------------------------------  
      procedure swapElResto(v1,v2: in out tpVector) is
      begin
         if v1'first<=v1'last then
            swap(v1(v1'first),v2(v2'first));
            swapElResto(v1(v1'first+1..v1'last),v2(v2'first+1..v2'last));
         end if;
      end swapElResto;
      -------------------------------------------------------------------------             
      aux1,aux2:tpDato;
   begin
      if v'first<=v1l and v1l+1<=v'last then
         aux1:=v(v'first);
         v(v'first):=v(v1l+1);
         if pivote=v1l+1 then 
            v(pivote):=aux1;
            swapElResto(v(v'first+1..v1l),v(v1l+2..v'last));
         else
            aux2:=v(pivote);
            v(pivote):=aux1;
            if pivote<=v1l then
               ioSwap(v,v1l,v'last-(v1l-pivote),aux2);
            else --pivote>v1l+1
               ioSwap(v,v1l,v'first+(pivote-(v1l+1)),aux2);
            end if;
         end if;
      end if;
   end oSwap;
   ----------------------------------------------------------------------------
   
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   --                  ALGORITMOS DE BUSQUEDA                                --                  
   ----------------------------------------------------------------------------
   ---------------------------------------------------------------------------- 
   
   ----------------------------------------------------------------------------
   function busquedaBinariaAnt (
         V : Tpvector;
         D : Tpdato)
     return Integer is
      -------------------------------------------------------------------------
      -- Pre:  ordenado(v)
      -- Post: devuelve la posicin del primer elemento SUPERIOR!!
      -------------------------------------------------------------------------
      -- Variables
      medio:integer;
   begin
      if v'first<=v'last then
         Medio:=(v'first+v'last)/2;
         if v(Medio)<=d then
           return BusquedaBinariaAnt(v(medio+1..v'last),d);
         else
           return BusquedaBinariaAnt(v(v'first..medio-1),d);
         end if;
      else
         return V'first;
      end if;
   end Busquedabinariaant;
   ----------------------------------------------------------------------------
   
   ----------------------------------------------------------------------------
   function BusquedaBinariaPost (
         V : Tpvector;
         D : Tpdato)
     return Integer is
      -------------------------------------------------------------------------
      -- Pre:  ordenado(v)
      -- Post: devuelve la posicin del ultimo elemento INFERIOR ESTRICTO!!
      -------------------------------------------------------------------------
      -- Variables
      medio:integer;
   begin
      if v'first<=v'last then
         Medio:=(v'first+v'last)/2;
         if D<=v(Medio) then
           return BusquedaBinariaPost(v(v'first..medio-1),d);
         else
           return BusquedaBinariaPost(v(medio+1..v'last),d);
         end if;
      else
         return V'last;
      end if;
   end Busquedabinariapost;
   ----------------------------------------------------------------------------
   
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   --                        ALGORITMOS DE MERGE                             --                  
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
 
   ----------------------------------------------------------------------------
   procedure classicMerge (
         V1,
         V2 : Tpvector;v:out tpVector)
          is
         ----------------------------------------------------------------------
         -- Pre:  ordenado(v1) AND ordenado(v2)
         -- Post: creciente(v) AND permutacion(v,v1&v2)
         ----------------------------------------------------------------------
      begin
         if V1'First<=V1'Last then
            if V2'First<=V2'Last then
               if v1(V1'First)<=v2(V2'First) then
                  v(v'first):=V1(V1'First);
                  classicMerge(V1(V1'First+1..V1'Last),V2,v(v'first+1..v'last));
               else
                  v(v'first):=v2(v2'first);
                  classicMerge(V1,V2(V2'First+1..V2'Last),v(v'first+1..v'last));
               end if;
            else
               v:=v1;
            end if;
         else
            if V2'First<=V2'Last then
               v:=V2;
            end if;
         end if;


   end classicMerge;
   ----------------------------------------------------------------------------
   
      -------------------------------------------------------------------------
      procedure mergeSwap (
         v: in out Tpvector;
         v1l   :  integer) is
         -- Pre: ordenado( v(v'first..primero-1) ) 
         --      AND ordenado( v(primero..v'last) )
         -- Post: ordenado(v)
         ----------------------------------------------------------------------
         medio1,medio2,pivote:integer;
      begin
         if V'first<=v1l and v1l+1<=v'last then
               Medio1:=(V'First+v1l)/2;
               Medio2:=Busquedabinariapost(v(v1l+1..v'last),v(medio1));
               pivote:=medio1+medio2-v1l;
               swapConSwaps(v(medio1..medio2),v1l);
               mergeSwap(v(v'first..pivote-1),medio1-1);
               mergeSwap(v(pivote+1..v'last),medio2);   
         end if;
      end mergeSwap;
      -------------------------------------------------------------------------  
          
      -------------------------------------------------------------------------
      procedure oMerge (
         v: in out Tpvector;
         v1l   :  integer) is
         -- Pre: ordenado( v(v'first..primero-1) ) 
         --      AND ordenado( v(primero..v'last) )
         -- Post: ordenado(v)
         ----------------------------------------------------------------------
         medio1,medio2,pivote:integer;
      begin
         if V'first<=v1l and v1l+1<=v'last then
               Medio1:=(V'First+v1l)/2;
               Medio2:=Busquedabinariapost(v(v1l+1..v'last),v(medio1));
               pivote:=medio1+medio2-v1l;
               oSwap(v(medio1..medio2),v1l,pivote);
               oMerge(v(v'first..pivote-1),medio1-1);
               oMerge(v(pivote+1..v'last),medio2);   
         end if;
      end oMerge;
      -------------------------------------------------------------------------
      
      -------------------------------------------------------------------------
      procedure mergeInvirtiendo(
         v: in out Tpvector;
         v1l   :  integer) is
         -- Pre: ordenado( v(v'first..primero-1) ) 
         --      AND ordenado( v(primero..v'last) )
         -- Post: ordenado(v)
         ----------------------------------------------------------------------
         medio1,medio2,pivote:integer;
      begin
         if V'first<=v1l and v1l+1<=v'last then
               Medio1:=(V'First+v1l)/2;
               Medio2:=Busquedabinariapost(v(v1l+1..v'last),v(medio1));
               pivote:=medio1+medio2-v1l;
               swapInvirtiendo(v(medio1..medio2),pivote);
               mergeInvirtiendo(v(v'first..pivote-1),medio1-1);
               mergeInvirtiendo(v(pivote+1..v'last),medio2);   
         end if;
      end mergeInvirtiendo;
      -------------------------------------------------------------------------
      
      -------------------------------------------------------------------------
      procedure Merge (
         v1,v2   :  Tpvector;
         v: out Tpvector) is
         ----------------------------------------------------------------------
         -- Pre:  ordenado(v1) AND ordenado(v2)
         -- Post: creciente(v) AND permutacion(v,v1&v2)
         ----------------------------------------------------------------------
         medio1,medio2,pivote:integer;
      begin
         if V1'first<=v1'last then
            if v2'first<=v2'last then
               Medio1:=(V1'First+v1'last)/2;
               Medio2:=Busquedabinariapost(v2,v1(medio1));
               pivote:=(v'first+(medio1-v1'first)+(medio2-v2'first+1));
               v(pivote):=v1(medio1);
               Merge(v1(v1'first..medio1-1),v2(v2'first..medio2),v(v'first..pivote-1));
               Merge(v1(medio1+1..v1'last),v2(medio2+1..v2'last),v(pivote+1..v'last));
            else
               v:=v1;
            end if;
         elsif v2'first<=v2'last then
            v:=v2;   
         end if;
      end Merge;
      -------------------------------------------------------------------------
      
   ----------------------------------------------------------------------------
   procedure oMergeVectores (
         v: in out Tpvector;
         v1l   :  integer) is
         -- Pre: ordenado( v(v'first..primero-1) ) 
         --      AND ordenado( v(primero..v'last) )
         -- Post: ordenado(v)
         ----------------------------------------------------------------------
         --Memoria <= O(n/4)
         ----------------------------------------------------------------------
      procedure swapSubVectores (v:in out tpVector;v1l,pivote:integer)is
      --Pre: v=v1&v2
      --Post:v=v2&v1
      -------------------------------------------------------------------------
         v1Aux:tpVector(v'first..v1l);
         v2Aux:tpVector(v1l+1..v'last);
      begin
         if v1l-v'first+1<=v'last-v1l then
            v1Aux:=v(v'first..v1l);
            v(v'first..pivote-1):=v(v1l+1..v'last);
            v(pivote..v'last):=v1Aux;
         else
            v2Aux:=v(v1l+1..v'last);
            v(pivote..v'last):=v(v'first..v1l);
            v(v'first..pivote-1):=v2Aux;
         end if;
      end swapSubvectores;
      -------------------------------------------------------------------------
         medio1,medio2,pivote:integer;
      begin
         if V'first<=v1l and v1l+1<=v'last then
            Medio1:=(V'First+v1l)/2;
            Medio2:=Busquedabinariapost(v(v1l+1..v'last),v(medio1));   
            --ordenado( v(v'first..medio1)&v(medio2+1..v'last) )
            -- AND ordenado( v(medio1+1..v1l) )
            -- AND ordenado( v(v1l+1..medio2) )
            pivote:=medio1+medio2-v1l;
            swapSubVectores(v(medio1..medio2),v1l,pivote);
            oMergeVectores(v(v'first..pivote-1),medio1-1);
            oMergeVectores(v(pivote+1..v'last),medio2); 
            --ordenado(v)  
         end if;
      end oMergeVectores;
      
   ----------------------------------------------------------------------------
      
        
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------
   --                  ALGORITMOS DE ORDENACION                              --                  
   ----------------------------------------------------------------------------
   ----------------------------------------------------------------------------

   ----------------------------------------------------------------------------
   procedure Ordenacionporinsercion (V : in out Tpvector) is
         ----------------------------------------------------------------------
         -- Post: ordenado(v)
         -- memoria cte
         ----------------------------------------------------------------------
         -- Variables
         Indicein,
         Indicelim : Integer;
         Dato      : Tpdato;
      begin

         for Indice in V'First + 1..V'Last loop
            Dato := V(Indice);
            Indicein:= Indice;
            Indicelim:= V'First;
            while not (Indicein = Indicelim) loop
               if V(Indicein -1) <= Dato  then
                  Indicelim := Indicein;
               else
                  V(Indicein) := V(Indicein -1);
                  Indicein := Indicein -1;
               end if;
            end loop;
            V(Indicein) := Dato;
         end loop;

   end Ordenacionporinsercion;
   ----------------------------------------------------------------------------

   ----------------------------------------------------------------------------
   procedure quickSort (v : in out Tpvector) is
         ----------------------------------------------------------------------
         -- Post: ordenado(v)
         -- memoria cte
         ----------------------------------------------------------------------

         I,
         S      : Integer; --range t'range;
         Pivote : Tpdato;
      begin  -- de ordenacionPorHoare
         if v'First < v'Last then
            Pivote := v(v'First);
            I := v'First + 1;
            S := v'Last;
            while I < S + 1 loop
               if v(I) <= Pivote then
                  I := I + 1;
               elsif Pivote <= v(S) then
                  S := S - 1;
               else
                  Swap(v(I), v(S));
                  I := I + 1;
                  S := S - 1;
               end if;
            end loop;
            Swap(v(v'First), v(S));
            quickSort( v(v'First..S-1) );
            quickSort( v(S+1..v'Last)  );
         end if;
   end quickSort;
   ----------------------------------------------------------------------------
      
           
   

   ----------------------------------------------------------------------------
   procedure oCsort (V : in out Tpvector) is
         ----------------------------------------------------------------------
         -- Post: ordenado(v)
         -- memoria O(n log n)
         ----------------------------------------------------------------------



         Medio,medio1,medio2,pivote:Integer;
         vAux:tpVector(v'first..v'last);
      begin
         if  V'Last > V'First then--el vector tiene ms de un elemento
            Medio:=(V'First+V'Last)/2;
            Ocsort(V(V'First..Medio-1));
            Ocsort(V(Medio+1..V'Last));
            --ordenado( v(v'first..medio-1) ) AND ordenado( v(medio+1..v'last) )
            if v'first<=medio-1 or medio+1<=v'last then
               Medio1:=Busquedabinariaant(v(v'first..medio-1),v(medio));
               Medio2:=Busquedabinariapost(v(medio+1..v'last),v(medio));
               if medio1/=medio or medio2/=medio then
                  pivote:=medio1+medio2-medio;--Verificado
                  vAux(pivote):=v(medio);
                  merge(v(v'first..medio1-1),v(medio+1..medio2),vAux(v'first..pivote-1));
                  merge(v(medio1..medio-1),v(medio2+1..v'last),vAux(pivote+1..v'last));
                  v:=vAux;
               end if;
            end if;
            --ordenado(v)
         end if;
   end oCsort;
   ----------------------------------------------------------------------------
      
   ----------------------------------------------------------------------------
   procedure mergeSort (V : in out Tpvector) is
         ----------------------------------------------------------------------
         -- Post: ordenado(v)
         -- memoria O(n log n)
         ----------------------------------------------------------------------



         Medio:Integer;--range v'range;
         vAux:tpVector(v'first..v'last);
      begin
         if  V'Last > V'First then--el vector tiene ms de un elemento
            Medio:=(V'First+V'Last)/2;
            mergeSort(V(V'First..Medio));
            mergeSort(V(Medio+1..V'Last));
            merge(v(v'first..medio),v(medio+1..v'last),Vaux);
            v:=vAux;
         end if;
      end mergesort;
   ----------------------------------------------------------------------------
 
   ----------------------------------------------------------------------------
   procedure classicmergeSort (V : in out Tpvector) is
         ----------------------------------------------------------------------
         -- Post: ordenado(v)
         -- memoria O(n log n)
         ----------------------------------------------------------------------
         Medio:Integer;--range v'range;
         vAux:tpVector(v'first..v'last);
      begin
         if  V'Last > V'First then--el vector tiene ms de un elemento
            Medio:=(V'First+V'Last)/2;
            classicmergeSort(V(V'First..Medio));
            classicmergeSort(V(Medio+1..V'Last));
            --ordenado( v(v'first..medio) ) AND ordenado ( v(medio+1..v'last) )
            classicmerge(V(v'first..medio),v(medio+1..v'last),vAux);
            v:=vAux;
            --ordenado(v)
         end if;
      end classicmergesort;
      -------------------------------------------------------------------------
      

   end Ordenacion;
   ------------------------------------------------------------------------------

